%% DS Calculation

for i=1:sICs2
    for j=1:sICs1
        output = sprintf('initial(1).value%d=ICs1(%d);',j,j);
        eval(output);
        output = sprintf('initial(2).value%d=ICs2(%d);',j,i);
        eval(output);
    end
    [dataDM]=DSsensitivity(strcat(filename,identifier),time,{},{},species,parameters,{},initial,{});
    save(sprintf('%s_70IC_%d.mat',filename,i),'dataDM','-v7.3');
end

for i=1:sICs1
    initial=rmfield(initial,sprintf('value%d',i));
end

%% Loading DS data

for DSi=1:sICs2
    load(sprintf('%s_70IC_%d.mat',filename,DSi));
    [~,sPA]=size(dataDM.InitialCondition{1,1}.DynamicSensitivity.KineticParameter.value);
    for j=1:sICs1
        for k=1:sPro
        data.InitialCondition{sICs1*(DSi-1)+j}.StateValue(:,k)=dataDM.InitialCondition{j}.StateValue(:,proteins(k));
        data.InitialCondition{sICs1*(DSi-1)+j}.InitialCondition=dataDM.InitialCondition{j}.InitialCondition;
        for l=1:sPA
        data.InitialCondition{sICs1*(DSi-1)+j}.DynamicSensitivity.KineticParameter.value{l}(:,k)=dataDM.InitialCondition{j}.DynamicSensitivity.KineticParameter.value{l}(:,proteins(k));
        end
        end
    end
end 

data.time=dataDM.InitialCondition{2}.time;
data.StateName=dataDM.InitialCondition{2}.StateName;
data.ParameterName=dataDM.InitialCondition{2}.ParameterName;
data.ParameterValue=dataDM.InitialCondition{2}.ParameterValue;

clearvars dataDM

%%%% Relative dynamic sensitivity %%%%%
for i=1:sICs2
    for j=1:sICs1
        for k=1:sPA
            for l=1:sPro
            data.InitialCondition{sICs1*(i-1)+j}.RelativeDynamicSensitivity.KineticParameter.value{1,k}(:,l)= ...
                data.InitialCondition{sICs1*(i-1)+j}.DynamicSensitivity.KineticParameter.value{1,k}(:,l).*data.ParameterValue(k)./data.InitialCondition{sICs1*(i-1)+j}.StateValue(:,l);
            data.InitialCondition{sICs1*(i-1)+j}.RelativeDynamicSensitivity.KineticParameter.value{1,k}(1,l)=0;
            end
        end
    end
end

% For (H,E)=(0,0)
data.InitialCondition{1}.StateValue(time+1,1:sPro)=0;
for i=1:sPA
data.InitialCondition{1}.DynamicSensitivity.KineticParameter.value{1,i}(time+1,1:sPro)=0;
data.InitialCondition{1}.RelativeDynamicSensitivity.KineticParameter.value{1,i}(time+1,1:sPro)=0;
end

save(sprintf('%s_70IC_InH%0.1f%0.1f%0.1f_ForAnalysis.mat',filename,InH1,InH2,InH3),'data');

