function [] = DSA_4(varargin)

[xName,yName,xVal,yVal,tit] = CheckVarargin(varargin);

if isempty(xName)~=1
xlabel(xName,'FontName','Arial','FontSize',12);
end
if isempty(yName)~=1
ylabel(yName,'FontName','Arial','FontSize',12);
end
if isempty(xVal)~=1
xlim(xVal);
end
if isempty(yVal)~=1
ylim(yVal);
end
if isempty(tit)~=1
title(tit,'FontName','Arial','FontSize',12);
end
set(gca,'FontName','Arial','FontSize',12);

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                  CheckVarargin                          % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [xName,yName,xVal,yVal,tit] = CheckVarargin(info)

xName = {};
yName = {};
xVal = {};
yVal = {};
tit = {};
Nargin = length(info);

if Nargin >=6
    error('Error! Input array exceeds the avaliable value');
end
if Nargin >= 1
    xName = info{1,1};
end
if Nargin >= 2
    yName = info{1,2};
end
if Nargin >= 3
    xVal = info{1,3};
end
if Nargin >= 4
    yVal = info{1,4};
end
if Nargin >= 5
    tit = info{1,5};
end
end